Index: /palm/trunk/SOURCE/multi_agent_system_mod.f90
===================================================================
--- /palm/trunk/SOURCE/multi_agent_system_mod.f90	(revision 4841)
+++ /palm/trunk/SOURCE/multi_agent_system_mod.f90	(revision 4842)
@@ -24,4 +24,8 @@
 ! -----------------
 ! $Id$
+! reading of namelist file and actions in case of namelist errors revised so that statement labels
+! and goto statements are not required any more
+!
+! 4828 2021-01-05 11:21:41Z Giersch
 ! file re-formatted to follow the PALM coding standard
 !
@@ -3655,5 +3659,8 @@
     IMPLICIT NONE
 
-    CHARACTER (LEN=80) ::  line  !<
+    CHARACTER(LEN=100) ::  line  !< dummy string for current line in namelist file
+
+    INTEGER(iwp)  ::  io_status  !< status after reading the namelist file
+
 
     NAMELIST /agent_parameters/  a_rand_target,                                                    &
@@ -3699,26 +3706,25 @@
 
 !
-!-- Try to find agent package
+!-- Move to the beginning of the namelist file and try to find and read the namelist.
     REWIND ( 11 )
-    line = ' '
-    DO WHILE ( INDEX( line, '&agent_parameters' ) == 0 )
-       READ ( 11, '(A)', END=20 )  line
-    ENDDO
-    BACKSPACE ( 11 )
-
-!
-!-- Read user-defined namelist
-    READ ( 11, agent_parameters, ERR = 10, END = 20 )
-
-!
-!-- Set flag that indicates that agents are switched on
-    agents_active = .TRUE.
-    GOTO 20
-
-10    BACKSPACE( 11 )
-    READ( 11 , '(A)') line
-    CALL parin_fail_message( 'agent_parameters', line )
-
-20    CONTINUE
+    READ ( 11, agent_parameters, IOSTAT=io_status )
+
+!
+!-- Action depending on the READ status
+    IF ( io_status == 0 )  THEN
+!
+!--    agent_parameters namelist was found and read correctly. Set flag that indicates that agents
+!--    are switched on.
+       agents_active = .TRUE.
+
+    ELSEIF ( io_status > 0 )  THEN
+!
+!--    agent_parameters namelist was found but contained errors. Print an error message including
+!--    the line that caused the problem.
+       BACKSPACE( 11 )
+       READ( 11 , '(A)') line
+       CALL parin_fail_message( 'agent_parameters', line )
+
+    ENDIF
 
  END SUBROUTINE mas_parin
Index: /palm/trunk/SOURCE/nesting_offl_mod.f90
===================================================================
--- /palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4841)
+++ /palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4842)
@@ -24,4 +24,8 @@
 ! -----------------
 ! $Id$
+! reading of namelist file and actions in case of namelist errors revised so that statement labels
+! and goto statements are not required any more
+!
+! 4834 2021-01-07 10:28:00Z raasch
 ! file re-formatted to follow the PALM coding standard
 !
@@ -2448,34 +2452,29 @@
  SUBROUTINE nesting_offl_parin
 
-    CHARACTER (LEN=80) ::  line  !< dummy string that contains the current line of the parameter file
-
-
-    NAMELIST /nesting_offl_parameters/   nesting_offline
-
-    line = ' '
-
-!
-!-- Try to find stg package
-    REWIND ( 11 )
-    line = ' '
-    DO WHILE ( INDEX( line, '&nesting_offl_parameters' ) == 0 )
-       READ ( 11, '(A)', END=20 )  line
-    ENDDO
-    BACKSPACE ( 11 )
-
-!
-!-- Read namelist
-    READ ( 11, nesting_offl_parameters, ERR = 10, END = 20 )
-
-    GOTO 20
-
-10    BACKSPACE( 11 )
-    READ( 11 , '(A)') line
-    CALL parin_fail_message( 'nesting_offl_parameters', line )
-
-20    CONTINUE
-
+    CHARACTER(LEN=100) ::  line  !< dummy string that contains the current line of the parameter file
+    INTEGER(iwp) ::  io_status   !< status after reading the namelist file
+
+
+    NAMELIST /nesting_offl_parameters/  nesting_offline
+
+!
+!-- Move to the beginning of the namelist file and try to find and read the namelist.
+    REWIND( 11 )
+    READ( 11, nesting_offl_parameters, IOSTAT=io_status )
+
+!
+!-- Action depending on the READ status
+    IF ( io_status > 0 )  THEN
+!
+!--    nesting_offl_parameters namelist was found but contained errors. Print an error message
+!--    including the line that caused the problem.
+       BACKSPACE( 11 )
+       READ( 11 , '(A)' ) line
+       CALL parin_fail_message( 'nesting_offl_parameters', line )
+
+    ENDIF
 
  END SUBROUTINE nesting_offl_parin
+
 
 !--------------------------------------------------------------------------------------------------!
@@ -2500,4 +2499,5 @@
 
  END SUBROUTINE nesting_offl_header
+
 
 !--------------------------------------------------------------------------------------------------!
Index: /palm/trunk/SOURCE/ocean_mod.f90
===================================================================
--- /palm/trunk/SOURCE/ocean_mod.f90	(revision 4841)
+++ /palm/trunk/SOURCE/ocean_mod.f90	(revision 4842)
@@ -24,4 +24,8 @@
 ! -----------------
 ! $Id$
+! reading of namelist file and actions in case of namelist errors revised so that statement labels
+! and goto statements are not required any more
+!
+! 4828 2021-01-05 11:21:41Z Giersch
 ! file re-formatted to follow the PALM coding standard
 !
@@ -572,37 +576,48 @@
     IMPLICIT NONE
 
-    CHARACTER (LEN=80) ::  line  !< dummy string that contains the current line of the parameter file
-
-
-    NAMELIST /ocean_parameters/  bc_sa_t, bottom_salinityflux, salinity, sa_surface,               &
-                                 sa_vertical_gradient, sa_vertical_gradient_level,                 &
-                                 stokes_waveheight, stokes_wavelength, surface_cooling_spinup_time,&
-                                 top_salinityflux, wall_salinityflux, wave_breaking
-
-!
-!-- Try to find the namelist
-    REWIND ( 11 )
-    line = ' '
-    DO WHILE ( INDEX( line, '&ocean_parameters' ) == 0 )
-       READ ( 11, '(A)', END=12 )  line
-    ENDDO
-    BACKSPACE ( 11 )
-
-!
-!-- Read namelist
-    READ ( 11, ocean_parameters, ERR = 10 )
-!
-!-- Set switch that enables PALM's ocean mode
-    ocean_mode = .TRUE.
-
-    GOTO 12
-
- 10 BACKSPACE( 11 )
-    READ( 11 , '(A)') line
-    CALL parin_fail_message( 'ocean_parameters', line )
-
- 12 CONTINUE
+    CHARACTER(LEN=100) ::  line  !< dummy string that contains the current line of the parameter
+                                 !< file
+    INTEGER(iwp)  ::  io_status  !< status after reading the namelist file
+
+
+    NAMELIST /ocean_parameters/  bc_sa_t,                                                          &
+                                 bottom_salinityflux,                                              &
+                                 salinity,                                                         &
+                                 sa_surface,                                                       &
+                                 sa_vertical_gradient,                                             &
+                                 sa_vertical_gradient_level,                                       &
+                                 stokes_waveheight,                                                &
+                                 stokes_wavelength,                                                &
+                                 surface_cooling_spinup_time,                                      &
+                                 top_salinityflux,                                                 &
+                                 wall_salinityflux,                                                &
+                                 wave_breaking
+
+!
+!-- Move to the beginning of the namelist file and try to find and read the namelist called
+!-- ocean_parameters.
+    REWIND( 11 )
+    READ( 11, ocean_parameters, IOSTAT=io_status )
+
+!
+!-- Action depending on the READ status
+    IF ( io_status == 0 )  THEN
+!
+!--    ocean_parameters namelist was found and read correctly. Set switch that enables PALM's ocean
+!--    mode.
+       ocean_mode = .TRUE.
+
+    ELSEIF ( io_status > 0 )  THEN
+!
+!--    ocean_parameters namelist was found but contained errors. Print an error message including
+!--    the line that caused the problem.
+       BACKSPACE( 11 )
+       READ( 11 , '(A)') line
+       CALL parin_fail_message( 'ocean_parameters', line )
+
+    ENDIF
 
  END SUBROUTINE ocean_parin
+
 
 !--------------------------------------------------------------------------------------------------!
